/*
 * Copyright (c) 2005 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.ezweb;

import javax.servlet.http.HttpServletRequest;

import org.springframework.dao.DataAccessException;

import jp.sourceforge.livez.IllegalRequestException;
import jp.sourceforge.livez.MobilePhoneGenerator;
import jp.sourceforge.livez.dao.EZwebDAO;

/**
 * EZweb 端末情報を生成する携帯端末情報ジェネレータクラスです。
 * 
 * @author 杉澤 浩二
 */
public final class EZwebGenerator extends MobilePhoneGenerator<EZwebRequest, EZweb> {

	public static final String BEAN_ID = "ezwebGenerator";

	/**
	 * EZwebDAO を保持します。
	 */
	private EZwebDAO ezwebDAO = null;

	/**
	 * EZwebDAO を設定します。
	 * 
	 * @param ezwebDAO EZwebDAO
	 */
	public void setEzwebDAO(final EZwebDAO ezwebDAO) {
		this.ezwebDAO = ezwebDAO;
	}

	/**
	 * デフォルトコンストラクタです。
	 */
	public EZwebGenerator() {}

	/**
	 * EZweb 端末リクエスト情報から EZweb 端末情報を生成して返します。
	 * 
	 * @param r EZweb 端末リクエスト情報
	 * @return EZweb 端末情報
	 * @throws NullPointerException EZweb 端末リクエスト情報が <code>null</code> の場合
	 * @throws DataAccessException EZwebDAO の操作で例外が発生した場合
	 */
	@Override
	public EZweb create(final EZwebRequest r) throws NullPointerException, DataAccessException {
		final EZwebImpl result = new EZwebImpl();

		if (this.ezwebDAO != null) {
			jp.sourceforge.livez.dao.EZweb ezweb = ezwebDAO.load(r.getUserAgent().getId());
			if (ezweb != null)
				result.setup(ezweb);
		}

		result.setup(r);

		return result;
	}

	/**
	 * HTTP リクエスト情報から EZweb 端末情報を生成して返します。
	 * 
	 * @param request HTTPリクエスト情報
	 * @return EZweb 端末情報
	 * @throws NullPointerException HTTPリクエスト情報が <code>null</code> の場合
	 * @throws IllegalRequestException HTTPリクエスト情報が不正な場合
	 * @throws DataAccessException EZwebDAO の操作で例外が発生した場合
	 */
	@Override
	public EZweb create(final HttpServletRequest request) throws NullPointerException, IllegalRequestException, DataAccessException {
		return create(new EZwebRequestImpl(request));
	}

}
